#library "prophunt"
#include "zcommon.acs"

#define RANDOM_CLASS -1
#define TEAM_HUNTER 0
#define TEAM_PROP 1
#define PH_TAUNTS 0
#define PH_NAME 1
#define PLAYERMAX 64

int pteam[64];
int ptid[64];
int frozen;
int points[64];
int roundover;
int scoreboard[64][2];
int cdowntime;
int lives[64];
int unblocked[64];
int inf[64];
int numprops = 66;
int numprops0b = 65;
int noblind;

str props[66] = {"PropBFG","PropShotgun","PropChaingun","PropRocketLauncher","PropPlasmaRifle","PropChainsaw","PropSuperShotgun","PropMedkit","PropStimpack","PropHealthbonus","PropBerserk","PropBlueArmor","PropGreenArmor","PropArmorBonus","PropRadsuit","PropInfraRed","PropAllMap","PropSoulSphere","PropBlurSphere","PropInvulnerabilitySphere","PropCell","PropCellPack","PropClip","PropClipBox","PropShell","PropShellBox","PropRocketAmmo","PropBackPack","PropRocketBox","PropBlueCard","PropRedCard","PropYellowCard","PropBlueSkull","PropYellowSkull","PropRedSkull","PropHeadOnAStick","PropHeadsOnAStick","PropFloatingSkull","PropMegaSphere","PropStalagmite","PropBigTree","PropTorchTree","PropHeartColumn","PropTallRedColumn","PropTallGreenColumn","PropTechPillar","PropSkullColumn","PropShortGreenColumn","PropShortRedColumn","PropBurningBarrel","PropExplosiveBarrel","PropBlueTorch","PropRedTorch","PropGreenTorch","PropShortBlueTorch","PropShortRedTorch","PropShortGreenTorch","PropCandelabra","PropColumn","PropTechLamp","PropTechLamp2","PropEvilEye","PropHeadCandles","PropCandlestick","PropLiveStick","PropStalagtite"};

str mapprops[66] = {"BFG","Shotgun","Chaingun","RocketLauncher","PlasmaRifle","Chainsaw","SuperShotgun","Medkit","Stimpack","Healthbonus","Berserk","BlueArmor","GreenArmor","ArmorBonus","Radsuit","InfraRed","AllMap","SoulSphere","BlurSphere","InvulnerabilitySphere","Cell","CellPack","Clip","ClipBox","Shell","ShellBox","RocketAmmo","BackPack","RocketBox","BlueCard","RedCard","YellowCard","BlueSkull","YellowSkull","RedSkull","HeadOnAStick","HeadsOnAStick","FloatingSkull","MegaSphere","Stalagmite","BigTree","TorchTree","HeartColumn","TallRedColumn","TallGreenColumn","TechPillar","SkullColumn","ShortGreenColumn","ShortRedColumn","BurningBarrel","ExplosiveBarrel","BlueTorch","RedTorch","GreenTorch","ShortBlueTorch","ShortRedTorch","ShortGreenTorch","Candelabra","Column","TechLamp","TechLamp2","EvilEye","HeadCandles","Candlestick","LiveStick","Stalagtite"};

///* //debug

Script 100 OPEN
{	
	frozen = 1;
	consolecommand("SV_NoIdentifyTarget 1");
	consolecommand("SV_NoCrouch 1");
	consolecommand("SV_AllowCrouch 0");
	if (getcvar("PH_HIDETIME") == 0)
	{
		cdowntime = 30;
	}
	else
	{
		cdowntime = getcvar("PH_HIDETIME");
	}
	Until(cdowntime == 0)
	{
		SetFont("BIGFONT");
		HudMessageBold(s:"\ccProps have \cg", d:cdowntime, s:" \ccseconds left to hide."; HUDMSG_PLAIN, 2, CR_WHITE, 0.03, 0.85, 3.5);
		delay(35);
		cdowntime--;
	}
	frozen = 0;
	if (GetCVar("timelimit") == 0) { Terminate; }
	
	int Time = GetCVar("timelimit")*60 >> 16;
	Time--;
	Until(Time == 0)
	{
		if (Time <= 60){
			SetFont("BIGFONT");
			HudMessageBold(s:"Round Ends In: \cg", d:Time/60, s:":", d:(Time%60)/10, d:Time%10; HUDMSG_PLAIN, 2, CR_WHITE, 0.03, 0.85, 3.5);
			delay(35);
			Time--;
		}else if (Time > 60 && Time <= 180){
			SetFont("BIGFONT");
			HudMessageBold(s:"Round Ends In: \ck", d:Time/60, s:":", d:(Time%60)/10, d:Time%10; HUDMSG_PLAIN, 2, CR_WHITE, 0.03, 0.85, 3.5);
			delay(35);
			Time--;
		}else if (Time > 180){
			SetFont("BIGFONT");
			HudMessageBold(s:"Round Ends In: \cd", d:Time/60, s:":", d:(Time%60)/10, d:Time%10; HUDMSG_PLAIN, 2, CR_WHITE, 0.03, 0.85, 3.5);
			delay(35);
			Time--;
		}
	}
	roundover = 1;
	for(int i=0;i<64;i++)
	{
		SetFont("BIGFONT");
		HudMessageBold(s:"Round Ends In: \cm0:00"; HUDMSG_PLAIN, 2, CR_WHITE, 0.03, 0.85, 5);
		if(pteam[i]==0) thing_damage(1000+i,999,0);
	}
}



script 126 ENTER
{
	delay(5);
	Until(frozen == 0)
	{
		delay(1);
	}
	if (playerteam() == TEAM_HUNTER)
	{
		SpawnSpotForced("Telefragger",ptid[playernumber()],0,0);
	}
}

script 127 RESPAWN 
{
	delay(5);
	if (frozen == 0)
	{
		terminate;
	}
	Until(frozen == 0)
	{
		delay(1);
	}
	if (playerteam() == TEAM_HUNTER)
	{
		SpawnSpotForced("Telefragger",ptid[playernumber()],0,0);
	}
	//print(s:GetActorProperty(0,APROP_Species));//debug
}

script 128 (void) //for hunters
{
	SetResultValue(frozen);
}



script 101 enter 
{
	thing_changetid(0,playernumber()+1000);
	pteam[playernumber()]=playerteam();
	ptid[playernumber()] = playernumber()+1000;
	lives[playernumber()] = 1;
}

script 102 respawn 
{
	thing_changetid(0,playernumber()+1000);
	pteam[playernumber()]=playerteam();
	ptid[playernumber()] = playernumber()+1000;
	lives[playernumber()] = 1;
}

//END OF TIMER


//BLACK SCREEN ON START

script 103 enter
{
	if (playerteam() == 0)
	{
		delay(1);
		if (noblind == 1)
			terminate;
		SetFont("BIGFONT");
		HudMessage(s:"Keep your eyes closed while props hide! \n\nDon't forget your weapons have a grenade altfire!"; HUDMSG_PLAIN | HUDMSG_LOG, 3, CR_TAN, 1.5, 0.3, 20.0);
		if (PlayerIsSpectator(playernumber()) == 0)
			FadeTo (0, 0, 0, 1.0, 0.1);
		SetPlayerProperty(0,1,PROP_TOTALLYFROZEN);
		delay(35*cdowntime - 1);
		FadeTo (0, 0, 0, 0.0, 1.0);
		SetPlayerProperty(0,0,PROP_TOTALLYFROZEN);
		HudMessage(s:""; HUDMSG_PLAIN, 3, CR_WHITE, 0.7, 0.5, 0.0);
	}
	if (playerteam() == 1)
	{
		SetFont("BIGFONT");
		HudMessage(s:"You're a prop! Blend in with the scenery and you won't get caught. \n\nHint: Type 'turbo 1' to slow down."; HUDMSG_PLAIN | HUDMSG_LOG, 3, CR_TAN, 1.5, 0.3, 5.0);
	}
}

script 108 RESPAWN
{
	if (playerteam() == 0)	
	{
		delay(1);
		if (noblind == 1)
			terminate;
		SetPlayerProperty(0,1,PROP_TOTALLYFROZEN);
		SetFont("BIGFONT");
		HudMessage(s:"Keep your eyes closed while props hide! \n\nDon't forget your weapons have a grenade altfire!"; HUDMSG_PLAIN, 3, CR_TAN, 1.5, 0.3, 20.0);
		if (PlayerIsSpectator(playernumber()) == 0)
			FadeTo (0, 0, 0, 1.0, 1.0);
		//print(s:"Eyes should be closed");//debug
		//print(s:"108 respawn says frozen is",d:frozen); //debug
		
		while(frozen == 1)
		{
			delay(1);
		}
		FadeTo (0, 0, 0, 0.0, 1.0);
		SetPlayerProperty(0,0,PROP_TOTALLYFROZEN);
		HudMessage(s:""; HUDMSG_PLAIN, 3, CR_WHITE, 0.7, 0.5, 0.0);
	}
}


//SPAMMING GUNS HURTS LIKE HELL
//Shotgun
script 105 (void)
{
	if (getcvar("PH_SGDAMAGE") == 0)
	{
		DamageThing (5, MOD_UNKNOWN);
	}
	else
	{
		DamageThing (getcvar("PH_SGDAMAGE"), MOD_UNKNOWN);
	}
}
//Chaingun	
script 104 (void)
{
	if (getcvar("PH_CGDAMAGE") == 0)
	{
		DamageThing (2, MOD_UNKNOWN);
	}
	else
	{
		DamageThing (getcvar("PH_CGDAMAGE"), MOD_UNKNOWN);
	}
}
//Fist	
script 109 (void)
{
	if (getcvar("PH_FISTDAMAGE") == 0)
	{
		DamageThing (1, MOD_UNKNOWN);
	}
	else
	{
		DamageThing (getcvar("PH_FISTDAMAGE"), MOD_UNKNOWN);
	}
}
	
//KILLING A PROP GIVES LIFE 

script 106 ENTER
{
	if (playerteam() == 0)
	{
		int fcount = 0;
		while(TRUE)
		{
			if (playerfrags() - fcount > 0)
			{
				healthing(100);
				fcount = playerfrags();
				giveinventory("shell", 50 - CheckInventory("Shell"));
				giveinventory("clip", 200 - CheckInventory("clip"));
				giveinventory("cell", 300 - CheckInventory("cell"));
			}
			else if (playerfrags() - fcount < 0)
			{
				fcount = playerfrags();
			}
			delay(10);
		}
	}
}

//NO MUSIC PLEASE THIS IS ANNOYING WITH TAUNTS

script 107 OPEN CLIENTSIDE
{
	if (getcvar("PH_ENABLEMUSIC") == 0)
	{
		SetMusic("Silence", 0);
	}
}

script 112 ENTER //Force random script
{
	if (playerteam() == 1)
	{
		if (getcvar("ph_forcerandom") == 1)
		{
			int randnumber;
			int mapprop;
			//let's make random more random!
			
			int intpos = GetActorX(0) + GetActorY(0) + GetActorZ(0) >> 16;
			int byteangle = GetActorAngle(0) >> 8;
			int iterations2 = GetCvar("sv_oldseed") + playernumber()*3 + GetSectorLightLevel (0) + intpos + byteangle + random(1,20) + playercount();
			int iterations = abs(iterations2);
			if (iterations == 0)
			{
				iterations++;
			}
			//print(d:iterations);//debug
			//print(i:iterations);//debug
			if (getcvar("PH_MAPPROPSONLY") == 0)
			{
				for(int i = 0; i < iterations; i++)
				{
					randnumber = random(0,numprops0b);
					//print(d:randnumber); //debug
					i++;
				}
			}
			else if (getcvar("PH_MAPPROPSONLY") == 1) //check for props beihng on the map
			{
				int attempts;
				while(mapprop == 0 && attempts < 3000)
				{
					for(int h = 0; h < iterations; h++)
					{
						randnumber = random(0,numprops0b);
						//print(d:randnumber); //debug
						h++;
					}
					attempts++;
					if (thingcountname(mapprops[randnumber], 0) > 0)
						mapprop = 1;
				}
			}
			//print(s:"112");//debug
			//killIfNotRandom(0, playernumber());
			delay(5);
			//randnumber = random(0,64);
			if (getcvar("PH_MAPPROPSONLY") == 1)
			{
				print(s:"Morphing to random class (ph_forcerandom is on)");
				MorphActor(0,props[randnumber], "", 0x7fffffff, MRF_WHENINVULNERABLE | MRF_NEWTIDBEHAVIOUR | MRF_UNDOBYDEATH /*| MRF_UNDOBYDEATHFORCED*/, "PropMorphFog", "PropMorphFog");
			}
			else if (getPlayerInfo(playernumber(), PLAYERINFO_PLAYERCLASS) != RANDOM_CLASS)
			{
				print(s:"Morphing to random class (ph_forcerandom is on)");
				//MorphActor(0,props[random(0,64)],"",999999.0,0,"","");
				MorphActor(0,props[randnumber], "", 0x7fffffff, MRF_WHENINVULNERABLE | MRF_NEWTIDBEHAVIOUR | MRF_UNDOBYDEATH /*| MRF_UNDOBYDEATHFORCED*/, "PropMorphFog", "PropMorphFog");
			}
		}
	}
}

script 111 RESPAWN
{
	acs_executealways(112,0);
}

//more randomness

script 113 UNLOADING
{
	int seedcommand = strparam(s:"set sv_oldseed ", d:random(1,timer()));
    ConsoleCommand(seedcommand);
}

function int abs (int x)
{
    if (x < 0)
        return -x;

    return x;
}

script 120 ENTER CLIENTSIDE
{
	int kicked;
	while(kicked == 0)
	{
		if(getcvar("noise") == 1)
		{	
			consolecommand("noise 0");
			//print(s:"\cgUsing noise 1 is cheating, okay? HUE HUE HUE");
			//consolecommand("spectate");
			KickFromGame(playernumber(),"Using noise 1 is cheating, okay? HUE HUE HUE");
			kicked = 1;
		}
		delay(35);
	}
}

//give hunters health when prop spectates

script 121 (int gone) DISCONNECT
{
	points[gone] = 0;
	inf[playernumber()] = 0;
	if (lives[playernumber()] == 0)
	{
		terminate;
	}
	if (pteam[gone] == TEAM_PROP)
	{
		print(s:"Prop disconnected, adding health to hunters!");
		for (int i = 0 ; i < 64; i++)
		{
			if (PlayerInGame(i) == TRUE && pteam[i] == TEAM_HUNTER)
			{
				int newhealth;
				if (GetActorProperty(ptid[i],APROP_Health) + 40 > 100)
				{
					newhealth = 100;
				}
				else
				{
					newhealth = GetActorProperty(ptid[i],APROP_Health) + 40;
				}
				SetActorProperty(ptid[i],APROP_Health,newhealth);
			}
		}
	}
}

//give points to taunters
script 122 (void)
{
	if (frozen == 0 && roundover == 0)
	{
		points[playernumber()]++;
	}
}

//taunt rankings
script 123 OPEN
{
	Until(frozen == 0);
	{
		delay(15);
	}
	while (TRUE)
	{//code copied from what i did with zanrun
		for (int herp = 0; herp < 64; herp++) //for each entry in scoreboard
		{
			scoreboard[herp][PH_TAUNTS] = points[herp]; //set the value at index "herp" to the taunt score of player "herp"
			scoreboard[herp][PH_NAME] = herp + 1; //set the player number to be "herp" plus 1, for use with n:
		}
		int temp = 0;
		int temp2 = 0;
		for (int write = 0; write < PLAYERMAX; write++) //bubble sort
		{
			for (int sort = 0; sort < PLAYERMAX - 1; sort++)
			{
				if (scoreboard[sort][PH_TAUNTS] > scoreboard[sort + 1][PH_TAUNTS])
				{
					temp = scoreboard[sort + 1][PH_TAUNTS];
					scoreboard[sort + 1][PH_TAUNTS] = scoreboard[sort][PH_TAUNTS];
					scoreboard[sort][PH_TAUNTS] = temp;
					temp2 = scoreboard[sort + 1][PH_NAME];
					scoreboard[sort + 1][PH_NAME] = scoreboard[sort][PH_NAME];
					scoreboard[sort][PH_NAME] = temp2;
				}
			}
		}
		SetFont ("smallfont"); 
		if (scoreboard[63][PH_TAUNTS] == 0)
		{
			HudMessageBold(s:"",s:"\cc";HUDMSG_PLAIN, 3, CR_WHITE , 1.99, 0.965, 0);
		}
		else if (scoreboard[62][PH_TAUNTS] == 0)
		{
			HudMessageBold(s:"TOP 3 TAUNTERS \n\n",n:scoreboard[63][PH_NAME],s:" Taunt count: ",d:scoreboard[63][PH_TAUNTS];HUDMSG_PLAIN, 3, CR_WHITE , 1.99, 0.945, 0);
		}
		else if (scoreboard[61][PH_TAUNTS] == 0)
		{
			HudMessageBold(s:"TOP 3 TAUNTERS \n\n",n:scoreboard[63][PH_NAME],s:" Taunt count: ",d:scoreboard[63][PH_TAUNTS],s:"\n\n",n:scoreboard[62][PH_NAME],s:" Taunt count: ",d:scoreboard[62][PH_TAUNTS];HUDMSG_PLAIN, 3, CR_WHITE , 1.99, 0.945, 0);
		}
		else
		{
			HudMessageBold(s:"TOP 3 TAUNTERS \n\n",n:scoreboard[63][PH_NAME],s:" Taunt count: ",d:scoreboard[63][PH_TAUNTS],s:"\n\n",n:scoreboard[62][PH_NAME],s:" Taunt count: ",d:scoreboard[62][PH_TAUNTS],s:"\n\n",n:scoreboard[61][PH_NAME],s:" Taunt count: ",d:scoreboard[61][PH_TAUNTS],s:"\cc";HUDMSG_PLAIN, 3, CR_WHITE , 1.99, 0.945, 0);
		}
		delay(35*3);
	}
}

script 124 DEATH
{
	points[playernumber()] = 0;
	lives[playernumber()] = 0;
	inf[playernumber()] = 0;
	/*if (playerteam() == TEAM_PROP)
	{
		if (getcvar("ph_forcerandom") == 1)
		{
			delay(3);
			StopSound(0,1);
		}
	}*/
}

script 125 (void) //infinite taunt activated
{
	inf[playernumber()] = 1;
	while(inf[playernumber()] == 1)
	{
		if (frozen == 0 && roundover == 0)
			points[playernumber()]++;
		delay(35*4);
	}
}

//=======Prox Player, from commonfuncs by ijon

function int min(int x, int y)
{
    if (x < y) { return x; }
    return y;
}

function int max(int x, int y)
{
    if (x > y) { return x; }
    return y;
}

function int cond(int test, int trueRet, int falseRet)
{
    if (test) { return trueRet; }
    return falseRet;
}

function int magnitudeThree_f(int x, int y, int z)
{
    int len, ang;

    ang = VectorAngle(x, y);
    if (((ang + 0.125) % 0.5) > 0.25) { len = FixedDiv(y, sin(ang)); }
    else { len = FixedDiv(x, cos(ang)); }

    ang = VectorAngle(len, z);
    if (((ang + 0.125) % 0.5) > 0.25) { len = FixedDiv(z, sin(ang)); }
    else { len = FixedDiv(len, cos(ang)); }

    return len;
}

function int distance(int x1, int y1, int z1, int x2, int y2, int z2)
{
    return magnitudeThree_f(x2-x1, y2-y1, z2-z1);
}

function int distance_ftoi(int x1, int y1, int z1, int x2, int y2, int z2)
{
    return distance(x1,y1,z1, x2,y2,z2) >> 16;
}

// These declarations must be there

int PlayerCoordinates[PLAYERMAX][3];
int PlayerDead[PLAYERMAX];
int PlayerEnters[PLAYERMAX];
int PlayerTIDs[PLAYERMAX];

// Convenience functions

function int GetPlayerX(int pln) { return PlayerCoordinates[pln][0]; }
function int GetPlayerY(int pln) { return PlayerCoordinates[pln][1]; }
function int GetPlayerZ(int pln) { return PlayerCoordinates[pln][2]; }

function int PlayerDistance(int pl1, int pl2)
{
    int x1 = GetPlayerX(pl1), x2 = GetPlayerX(pl2);
    int y1 = GetPlayerY(pl1), y2 = GetPlayerY(pl2);
    int z1 = GetPlayerZ(pl1), z2 = GetPlayerZ(pl2);
    
    return distance_ftoi(x1, y1, z1, x2, y2, z2);
}


// The below is necessary; it sets the coordinates of the player, and whether
// they're dead or not, in the PlayerCoordinates and PlayerDead arrays

#define PROXPLAYER_ENTER        392
#define PROXPLAYER_RETURN       393
#define PROXPLAYER_SPAWN        394

function void SetCoordinates(int pln, int x, int y, int z)
{
    PlayerCoordinates[pln][0] = x;
    PlayerCoordinates[pln][1] = y;
    PlayerCoordinates[pln][2] = z;
}

script PROXPLAYER_ENTER  enter  { ACS_ExecuteWithResult(PROXPLAYER_SPAWN, 0,0,0); }
script PROXPLAYER_RETURN return { ACS_ExecuteWithResult(PROXPLAYER_SPAWN, 0,0,0); }

script PROXPLAYER_SPAWN (int respawning)
{
    int pln = PlayerNumber();
    int startTime = Timer();
    int i;
    PlayerEnters[pln] = startTime;

    if (!respawning)
    {
        //Print(s:"Puke script -", d:PROXPLAYER_DEBUG, s:" to run the debug script.");
    }

    while (PlayerEnters[pln] == startTime)
    {
        SetCoordinates(pln, GetActorX(0), GetActorY(0), GetActorZ(0));
        PlayerDead[pln] = GetActorProperty(0, APROP_Health) <= 0;
		PlayerTIDs[pln] = ActivatorTID();
        Delay(1);
    }
}

//==== End of proxplayer

script 747 (void) //Checks proximity, thanks to Ijon for proxplayer
{
	//print(s:"747"); //debug
	int blocked = 0;
	for(int otherPln = 0; otherPln <64; otherPln++)
	{
		if (otherPln == playernumber()|| !PlayerInGame(otherPln) || PlayerDead[otherPln] )
		{
			continue;
		}
		else if (PlayerDistance(playernumber(), otherPln) > 50)
		{
			//print(d:PlayerDistance(playernumber(), otherPln)); //debug
			continue;
		}
		else if (PlayerDistance(playernumber(), otherPln) < 51)
		{
			if (playerteam() == TEAM_HUNTER && GetPlayerInfo(otherPln, PLAYERINFO_TEAM) == TEAM_HUNTER)
			{
				continue;
			}
			else
			{
				blocked = 1;
				//print(d:PlayerDistance(playernumber(), otherPln)); //debug
				break;
			}
		}
	}
	if (blocked == 0)
	{
		int spawnsuccess = SpawnSpot ("invisblockcheck", ptid[64], 3000 + playernumber());
		//print(d:spawnsuccess); //debug
		if (spawnsuccess == 0)
		{
			blocked = 1;
		}
		else
		{
			Thing_Destroy(3000 + playernumber(),0);
		}
	}
	//print(s:"blocked: ",d:blocked); //debug
	if (blocked == 0)
		unblocked[playernumber()] = 1;
	SetResultValue(blocked);
}

script 748 ENTER
{
	delay(10);
	while(unblocked[playernumber()] == 0)
	{
		if (frozen == 1)
		{
			if (playerteam() == TEAM_PROP)
				giveinventory("PropGhoster2",1);
		}
		else
		{
			giveinventory("PropGhoster2",1);
		}
		delay(15);
	}
}

script 749 RESPAWN
{
	acs_execute(748,0);
}

script 200 OPEN CLIENTSIDE //I really really hate myself for doing this -_-
{
	consolecommand("gl_spriteclip 0");
	consolecommand("gl_use_models 0");
	delay(1);
	restart;
}

script 750 (void) // A map must trigger this in the very first tic if they don't want their hunters to get frozen
{
	noblind = 1;
}

script 751 (void) CLIENTSIDE
{
	if (getcvar("PH_NOTAUNTS") == 1)
	{
		giveinventory("SoundStopper",1);
	}
}

script 231 (void) //debug
{
	print(s:"Stopping sound");
}

script "NoGameboy" (void)
{
    SetResultValue(GetCvar("NoGameboy"));
}

script "AlternateChaingunSkin" (void)
{
    SetResultValue(GetCvar("AlternateChaingunSkin"));
}